﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace boca_sample
{
    public partial class FrmChoice : Form
    {
        private FrmBoca m_parent;

        public FrmChoice(FrmBoca frm1)
        {
            InitializeComponent();
            m_parent = frm1;
        }

        private void FrmChoice_Load(object sender, EventArgs e)
        {
            option1.Visible = false;
            option2.Visible = false;
            option3.Visible = false;
            option4.Visible = false;
            option5.Visible = false;
            option6.Visible = false;
            option7.Visible = false;
            option8.Visible = false;
            option9.Visible = false;
            option10.Visible = false;

            Text = "Please choose one";
            switch (boca_sample.FrmBoca.choice_index)
            {
                case 1:

                    Text = "Choose Interface for communication";
                    option1.Text = "USB - HID Mode";
                    option2.Text = "ETHERNET";
                    option3.Text = "LPT1";
                    option4.Text = "LPT2";
                    option5.Text = "LPT3";
                    option6.Text = "LPT4";
                    option7.Text = "COM1";
                    option8.Text = "COM2";
                    option9.Text = "COM3";
                    option10.Text = "COM4";
                    option1.Visible = true;
                    option2.Visible = true;
                    option3.Visible = true;
                    option4.Visible = true;
                    option5.Visible = true;
                    option6.Visible = true;
                    option7.Visible = true;
                    option8.Visible = true;
                    option9.Visible = true;
                    option10.Visible = true;
                    
                    break;

                case 11:
                    
                    Text = "Choose Port(s) to return status";
                    option1.Text = "None";
                    option2.Text = "Serial";
                    option3.Text = "Parallel";
                    option4.Text = "Ser/Par";
                    option5.Text = "USB";
                    option6.Text = "USB/Ser";
                    option7.Text = "USB/Par";
                    option8.Text = "USB/Ser/Par";
                    option9.Text = "";
                    option10.Text = "";
                    option1.Visible = true;
                    option2.Visible = true;
                    option3.Visible = true;
                    option4.Visible = true;
                    option5.Visible = true;
                    option6.Visible = true;
                    option7.Visible = true;
                    option8.Visible = true;
                    option9.Visible = false;
                    option10.Visible = false;

                    break;
                case 13:
                    Text = "Enable FGL Commands for PCL?";
                    option1.Text = "Yes";
                    option2.Text = "No";
                    option3.Text = "";
                    option4.Text = "";
                    option5.Text = "";
                    option6.Text = "";
                    option7.Text = "";
                    option8.Text = "";
                    option9.Text = "";
                    option10.Text = "";
                    option1.Visible = true;
                    option2.Visible = true;
                    option3.Visible = false;
                    option4.Visible = false;
                    option5.Visible = false;
                    option6.Visible = false;
                    option7.Visible = false;
                    option8.Visible = false;
                    option9.Visible = false;
                    option10.Visible = false;


                    break;
                case 16:
                    Text = "Enable Ethernet Port Mode?";
                    option1.Text = "No - Disabled";
                    option2.Text = "Yes - Enabled";
                    option3.Text = "Diagnostic Mode";
                    option4.Text = "Valid Packets Mode";
                    option5.Text = "DHCP Mode";
                    option6.Text = "DHCP/SUB/Gate Mode";
                    option7.Text = "DHCP/NR Mode";
                    option8.Text = "DHCP/SUB/Gate/NR Mode";
                    option9.Text = "";
                    option10.Text = "";
                    option1.Visible = true;
                    option2.Visible = true;
                    option3.Visible = true;
                    option4.Visible = true;
                    option5.Visible = true;
                    option6.Visible = true;
                    option7.Visible = true;
                    option8.Visible = true;
                    option9.Visible = false;
                    option10.Visible = false;

                    break;
                case 17:
                    Text = "Enable Bi-Directional Parallel?";
                    option1.Text = "Yes";
                    option2.Text = "No";
                    option3.Text = "";
                    option4.Text = "";
                    option5.Text = "";
                    option6.Text = "";
                    option7.Text = "";
                    option8.Text = "";
                    option9.Text = "";
                    option10.Text = "";
                    option1.Visible = true;
                    option2.Visible = true;
                    option3.Visible = false;
                    option4.Visible = false;
                    option5.Visible = false;
                    option6.Visible = false;
                    option7.Visible = false;
                    option8.Visible = false;
                    option9.Visible = false;
                    option10.Visible = false;

                    break;
                case 51:
                    Text = "Choose the Printer Path";
                    option1.Text = "1 (Default)";
                    option2.Text = "2";
                    option3.Text = "3";
                    option4.Text = "4";
                    option5.Text = "5";
                    option6.Text = "6";
                    option7.Text = "7";
                    option8.Text = "";
                    option9.Text = "";
                    option10.Text = "";
                    option1.Visible = true;
                    option2.Visible = true;
                    option3.Visible = true;
                    option4.Visible = true;
                    option5.Visible = true;
                    option6.Visible = true;
                    option7.Visible = true;
                    option8.Visible = false;
                    option9.Visible = false;
                    option10.Visible = false;

                    break;
                case 52:
                    Text = "Choose Path Type";
                    option1.Text = "Path 1";
                    option2.Text = "Path 2";
                    option3.Text = "Dual";
                    option4.Text = "Dual Supply";
                    option5.Text = "Ventek Dual";
                    option6.Text = "";
                    option7.Text = "";
                    option8.Text = "";
                    option9.Text = "";
                    option10.Text = "";
                    option1.Visible = true;
                    option2.Visible = true;
                    option3.Visible = true;
                    option4.Visible = true;
                    option5.Visible = true;
                    option6.Visible = false;
                    option7.Visible = false;
                    option8.Visible = false;
                    option9.Visible = false;
                    option10.Visible = false;

                    break;

                default:
                    MessageBox.Show("Unknown Configuration Item, Please reselect");
                    break;

            
            }
        }

        private void CmdOk2_Click(object sender, EventArgs e)
        {

            string fgl_command, text_command;
            bool reset;

            reset = false;
            fgl_command = "";
            text_command = "";

            switch (FrmBoca.choice_index)
            {
                case 1:                                             //Select an Interface
                    fgl_command = "";                               //nothing to run at end of the routine
                    m_parent.Current_Port_Name = "";                //initialize
                    //Establish which port was choosen
                    if (option1.Checked == true)
                    {
                        m_parent.Current_Port_Name = "USB - HID Mode";
                    }
                    else if (option2.Checked == true)
                    {
                        m_parent.Current_Port_Name = "ETHERNET";
                    }
                    else if (option3.Checked == true)
                    {
                        m_parent.Current_Port_Name = "LPT1";
                    }
                    else if (option4.Checked == true)
                    {
                        m_parent.Current_Port_Name = "LPT2";
                    }
                    else if (option5.Checked == true)
                    {
                        m_parent.Current_Port_Name = "LPT3";
                    }
                    else if (option6.Checked == true)
                    {
                        m_parent.Current_Port_Name = "LPT4";
                    }
                    else if (option7.Checked == true)
                    {
                        m_parent.Current_Port_Name = "COM1";
                    }
                    else if (option8.Checked == true)
                    {
                        m_parent.Current_Port_Name = "COM2";
                    }
                    else if (option9.Checked == true)
                    {
                        m_parent.Current_Port_Name = "COM3";
                    }
                    else if (option9.Checked == true)
                    {
                        m_parent.Current_Port_Name = "COM4";
                    }
                    this.Close();
                    m_parent.port_open();

                    break;

                case 11:                                            //Status Enabled
                    if (option1.Checked == true)
                    {
                        fgl_command = "<se0>";
                        text_command = "Status None";
                    }
                    else if (option2.Checked == true)
                    {
                        fgl_command = "<se1>";
                        text_command = "Status Serial";
                    }
                    else if (option3.Checked == true)
                    {
                        fgl_command = "<se2>";
                        text_command = "Status Parallel";
                    }
                    else if (option4.Checked == true)
                    {
                        fgl_command = "<se3>";
                        text_command = "Status SER/PAR";
                    }
                    else if (option5.Checked == true)
                    {
                        fgl_command = "<se4>";
                        text_command = "Status USB";
                    }
                    else if (option6.Checked == true)
                    {
                        fgl_command = "<se5>";
                        text_command = "Status USB/SER";
                    }
                    else if (option7.Checked == true)
                    {
                        fgl_command = "<se6>";
                        text_command = "Status USB/PAR";
                    }
                    else if (option8.Checked == true)
                    {
                        fgl_command = "<se7>";
                        text_command = "Status USB/SER/PAR";
                    }
 
                    break;
                case 12:                                                    //Baud Rate
                    break;

                case 13:                                                    //FGL Command Enabled
                    if (option1.Checked == true)
                    {
                        fgl_command = "<VS1>";
                        text_command = "FGL Commands Enabled for PCL";
                    }
                    else if (option2.Checked == true)
                    {
                        fgl_command = "<VS2>";
                        text_command = "FGL Commands Disabled for PCL";
                    } 
                    break;

                case 16:                                                //Enable Ethernet
                    if (option1.Checked == true)
                    {
                        fgl_command = "<eth0>";                         //Disabled
                        text_command = "Ethernet Port Disable";
                    }
                    else if (option2.Checked == true)
                    {
                        fgl_command = "<eth1>";
                        text_command = "Ethernet Port Enable";
                    }
                    else if (option3.Checked == true)
                    {
                        fgl_command = "<eth2>";
                        text_command = "Ethernet Port Diagnostic Mode";
                    }
                    else if (option4.Checked == true)
                    {
                        fgl_command = "<eth3>";
                        text_command = "Ethernet Port Validity Mode";
                    }
                    else if (option5.Checked == true)
                    {
                        fgl_command = "<eth4>";
                        text_command = "Ethernet DHCP Mode";
                    }
                    else if (option6.Checked == true)
                    {
                        fgl_command = "<eth5>";
                        text_command = "Ethernet DHCP/SUB/Gate Mode";
                    }
                    else if (option7.Checked == true)
                    {
                        fgl_command = "<eth6>";
                        text_command = "Ethernet DHCP/NR Mode";
                    }
                    else if (option8.Checked == true)
                    {
                        fgl_command = "<eth7>";
                        text_command = "Ethernet DHCP/SUB/Gate/NR Mode";
                    }
 
                    break;
                case 17:                                                //Bi-directional Parallel
                    if (option1.Checked == true)
                    {
                        fgl_command = "<bpe>";
                        text_command = "Bi-Directional Parallel Enable";
                    }
                    else if (option2.Checked == true)
                    {
                        fgl_command = "<bpd>";
                        text_command = "Bi-Directional Parallel Disable";
                    }
 
                   break;
                case 51:            //Printer path type
                    if (option1.Checked == true)
                    {
                        fgl_command = "<P1>";
                        text_command = "Path One";
                    }
                    else if (option2.Checked == true)
                    {
                        fgl_command = "<P2>";
                        text_command = "Path Two";
                    }
                    else if (option3.Checked == true)
                    {
                        fgl_command = "<P3>";
                        text_command = "Path Three";
                    }
                    else if (option4.Checked == true)
                    {
                        fgl_command = "<P4>";
                        text_command = "Path Four";
                    }
                    else if (option5.Checked == true)
                    {
                        fgl_command = "<P5>";
                        text_command = "Path Five";
                    }
                    else if (option6.Checked == true)
                    {
                        fgl_command = "<P6>";
                        text_command = "Path Six";
                    }
                    else if (option7.Checked == true)
                    {
                        fgl_command = "<P7>";
                        text_command = "Path Seven";
                    }
                    else    //default
                    {
                        fgl_command = "<P1>";
                        text_command = "Default Path One";
                    }
 
                   break;

                case 52:            //Path type as part of Set current state Factory default
                    fgl_command = "exit";
                    if (option1.Checked == true)
                    {
                        boca_sample.FrmBoca.path_type_string = "<p1>";
                        //fgl_command = "<p1>";           //Path 1
                        text_command = "Path 1";
                    }
                    else if (option2.Checked == true)
                    {
                        boca_sample.FrmBoca.path_type_string = "<p2>";           //Path 2
                        text_command = "Path 2";
                    }
                    else if (option3.Checked == true)
                    {
                        boca_sample.FrmBoca.path_type_string = "<pb1>";           //Dual
                        text_command = "Dual";
                    }
                    else if (option4.Checked == true)
                    {
                        boca_sample.FrmBoca.path_type_string = "<pb2>";           //Dual Supply
                        text_command = "Dual Supply";
                    }
                    else if (option5.Checked == true)
                    {
                        boca_sample.FrmBoca.path_type_string = "<pb3>";           //Ventek Dual
                        text_command = "Ventek Dual";
                    }

                    
                    FrmBoca.choice_index = 18;                          //Indicate Change Serial Number
                    FrmNum fn = new FrmNum(m_parent);                   //create an instance of the number form
                    fn.Show();                                          //display form

                        break;

                case 58:            //Updater Option
                  
                    break;

                //this is the default
                default:
                   break;
            }   //switch

            this.Close();

            //Verify there is a command to issue
            if (fgl_command != "")
            {
                //Verify it is not just exit
                if (fgl_command != "exit")
                {
                    //prepend the tranparent mode off command to outgoing configuration commands
                    fgl_command = "<n>" + fgl_command;
                    m_parent.Transmit(fgl_command);       //Issue command

                    string s = "Sent " + text_command + " command " + fgl_command + " to the printer.";   //Display command on screen
                    m_parent.Display_Text(s);
                }
                if (reset)
                {
                    reset = false;
                }
            }
            else
            {
                //'Call Display_Text("No Command was Sent to the printer.")  'Display command on screen
                //if (formnum != 58) 
                //    Display_Text ("No Command was Sent to the printer.")        //Display command on screen
            }
  
        }

        private void CmdCancel2_Click(object sender, EventArgs e)
        {
            FrmChoice.ActiveForm.Close();

        }
    }
}
