﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using boca_sample;

namespace boca_sample
{
    public partial class FrmText : Form
    {
        public static FrmText staticVar = null;
        private FrmBoca m_parent;
        
        public FrmText(FrmBoca frm1)
        {
            InitializeComponent();
            m_parent = frm1;
        }

        private void CmdOk_Click(object sender, EventArgs e)
        {

            FrmBoca t1 = new FrmBoca();
            if (OptAscii.Checked)
            {
                m_parent.Transmit(TxtCmd.Text);                                               //Transmit ASCII string
            }
            else
            {
                //string unicode;
                byte[] byte_array = new byte[TxtCmd.Text.Length];
                byte_array = System.Text.Encoding.Unicode.GetBytes(TxtCmd.Text);            //Convert ASCII string to Unicode byte array
                m_parent.Transmitb(byte_array);                                             //Transmit Unicode byte array
            }
            
        }

        private void CmdCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

    }
}
